#![feature(box_as_ptr, let_chains)]

extern crate async_std;
extern crate juno_build;

use core::ptr::copy_nonoverlapping;

juno_build::juno!("dot");

fn main() {
    async_std::task::block_on(async {
        let a: Box<[f32]> = Box::new([0.0, 1.0, 0.0, 2.0, 0.0, 3.0, 0.0, 4.0]);
        let b: Box<[f32]> = Box::new([0.0, 5.0, 0.0, 6.0, 0.0, 7.0, 0.0, 8.0]);
        let mut a_bytes: Box<[u8]> = Box::new([0; 32]);
        let mut b_bytes: Box<[u8]> = Box::new([0; 32]);
        unsafe {
            copy_nonoverlapping(
                Box::as_ptr(&a) as *const u8,
                Box::as_mut_ptr(&mut a_bytes) as *mut u8,
                32,
            );
            copy_nonoverlapping(
                Box::as_ptr(&b) as *const u8,
                Box::as_mut_ptr(&mut b_bytes) as *mut u8,
                32,
            );
        };
        let c = dot(8, a_bytes, b_bytes).await;
        println!("{}", c);
        assert_eq!(c, 70.0);
    });
}

#[test]
fn dot_test() {
    main();
}
