#![feature(box_as_ptr, let_chains)]

extern crate async_std;
extern crate juno_build;

use core::ptr::copy_nonoverlapping;

juno_build::juno!("nested_ccp");

fn main() {
    async_std::task::block_on(async {
        let a: Box<[f32]> = Box::new([17.0, 18.0, 19.0]);
        let b: Box<[i32]> = Box::new([12, 16, 4, 18, 23, 56, 93, 22, 14]);
        let mut a_bytes: Box<[u8]> = Box::new([0; 12]);
        let mut b_bytes: Box<[u8]> = Box::new([0; 36]);
        unsafe {
            copy_nonoverlapping(
                Box::as_ptr(&a) as *const u8,
                Box::as_mut_ptr(&mut a_bytes) as *mut u8,
                12,
            );
            copy_nonoverlapping(
                Box::as_ptr(&b) as *const u8,
                Box::as_mut_ptr(&mut b_bytes) as *mut u8,
                36,
            );
        };
        let output_example = ccp_example(a_bytes).await;
        let output_median = median_array(9, b_bytes).await;
        println!("{}", output_example);
        println!("{}", output_median);
        assert_eq!(output_example, 1.0);
        assert_eq!(output_median, 18);
    });
}

#[test]
fn nested_ccp_test() {
    main();
}
