#![feature(box_as_ptr, let_chains)]

extern crate async_std;
extern crate juno_build;

use core::ptr::copy_nonoverlapping;

juno_build::juno!("simple3");

fn main() {
    async_std::task::block_on(async {
        let a: Box<[u32]> = Box::new([1, 2, 3, 4, 5, 6, 7, 8]);
        let b: Box<[u32]> = Box::new([8, 7, 6, 5, 4, 3, 2, 1]);
        let mut a_bytes: Box<[u8]> = Box::new([0; 32]);
        let mut b_bytes: Box<[u8]> = Box::new([0; 32]);
        unsafe {
            copy_nonoverlapping(
                Box::as_ptr(&a) as *const u8,
                Box::as_mut_ptr(&mut a_bytes) as *mut u8,
                32,
            );
            copy_nonoverlapping(
                Box::as_ptr(&b) as *const u8,
                Box::as_mut_ptr(&mut b_bytes) as *mut u8,
                32,
            );
        };
        let c = simple3(8, a_bytes, b_bytes).await;
        println!("{}", c);
        assert_eq!(c, 120);
    });
}

#[test]
fn simple3_test() {
    main();
}
